// Script for controlling slaves with subcontrol
setInfos(6, "subcontrol_control", "Script for controlling slaves using subcontrol script, NOT for subs",
		"Liz", "v1.2.1", 0x222222, "en", ["maledom","femaledom","internet"]);

// 170207 - Version 1.2.1 - Fix so can update control profile
// 170123 - Version 1.2 - Saving data so will be readable by version 2
// 160526 - Version 1.1.7 - Update for new play-link server
// 150910 - Version 1.1.7 - Update for new play-link
// 150817 - Fixed bug in SlaveMarket
// 150806 - Read logs from Mobile version + SlaveMarket replacement
// 150601 - More optimisations to speed start-up
// 150529 - New Profile structure
def profile = [name: "Slave", pic: "", reviewwebcam : false, warnwebcam : false, picchance : 10, sex : false, toys : "", fetish : "", chastity : 0, cumfrom : 0, mistress : "", LastTask : "", LastTaskTime : 0, ImagesOfTask : "", TPic1 : "", TPic2 : "", TPic3 : ""]
// 150512 - Extra commands, forced punishment and better image buffer
// 150505 - Version 1.1.0 - Major updates to how tasks work + SlaveMarket + Tips etc
// 150403 - Version 1.0.0
// 150320 - First concept version


// ******************** Key Functions ************************************

// Function to Display smaller image when reviewing subs
//    SetImageSize(ImageFile,% size)
def setImageSize = { picture, psize ->
  if (picture == null) {
    setImage(null)
    return
  }
  def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
  def width = (int)((image.getWidth()*psize)/100)
  def height = (int)((image.getHeight()*psize)/100)
  if (width < 50) width = 50
  if (height < 100) height = 100
	
  def frameBuffer = new java.awt.image.BufferedImage( width,height,java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
  def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
  java.awt.Graphics2D graphics = frameBuffer.createGraphics()
  graphics.drawImage(sprite, 0, 0, width,height, null)
  java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
  javax.imageio.ImageIO.write(frameBuffer, "png", baos)
  setImage(baos.toByteArray(),0)
}	

// SendPLImage
//SendPLImage("111X111","Profile","test.img");
def SendPLImage = { pid, itype, filename ->
	def url = new java.net.URL('http://play-link.com/subcontrol/sendimage.php')

	def conn = url.openConnection();
	conn.setDoInput(true);
	conn.setDoOutput(true);
	conn.setRequestMethod("POST");
	conn.setReadTimeout(120 * 1000);
	conn.setRequestProperty("Accept",
		"text/html,application/xhtml+xml,"
			+ "application/xml;q=0.9,*/*;q=0.8");
	conn.setRequestProperty("Content-Type",
		"multipart/form-data; boundary=BoBoBoBa");
	conn.setRequestProperty("Accept-Encoding", "deflate");
	def os = conn.getOutputStream();
	def pw = new java.io.PrintWriter(os, true);

	pw.write("\n--BoBoBoBa\n")
	pw.write("Content-Disposition: form-data; name=\"id\"\n")
	pw.write("Content-Type: text/plain; charset=UTF-8\n\n")
	pw.write(pid)
	pw.write("\n--BoBoBoBa\n")
	pw.write("Content-Disposition: form-data; name=\"itype\"\n")
	pw.write("Content-Type: text/plain; charset=UTF-8\n\n")
	pw.write(itype)
	pw.flush();
	
	pw.write("\n--BoBoBoBa\n" +
			"Content-Disposition: form-data; name=\"fileToUpload\"; filename=\"image.jpg\"\n" +
			"Content-Transfert-encoding: binary\n" +
			"Content-Type: image/jpeg\n\n");
	pw.flush();
	def file = new File(filename)
	os.write(file.getBytes(), 0, file.getBytes().size());
	os.flush();
	pw.write("\n--BoBoBoBa--\n");
	pw.flush();
	
	def buffer = new byte[1024];
	def is = conn.getInputStream();
	is.read(buffer, 0, 1024);
	def allResponse = new String(buffer);
	is.close();
	return allResponse
}

// DownloadFile function to keep local version of tasks up-to-date so not needing to
// keep checking with server.. May also use for auto script update?
def downloadFile = { dlink,dfile ->
  int len1 = 0;
  InputStream is=null;
  OutputStream os=null;
  try {
    URL url=new URL(dlink);
    is=url.openStream();
    os=new FileOutputStream(new File("scripts/"+dfile));
    byte[] buff=new byte[4096];
    while (-1 != (len1=is.read(buff))) {
      os.write(buff,0,len1);
    }
    os.flush();
  }
  catch (  Exception ex) {
    return false;
  }
  finally {
    if (os != null) try {
      os.close();
    }
    catch (IOException ex) {
    }
    if (is != null) try {
      is.close();
    }
    catch (IOException ex) { }
  }
  return true;
}
// ******************** End of Key Functions ******************************

//Splash and version check - keep version numbers same for control and sub scripts so in sync?		
show(null)
setImage("subcontrol/msplash.png")
def this_version = 121 // -> 1.2.1
String ver_string = (Math.floor(this_version / 10)/10) + "." + (this_version % 10)

def latest_version = receiveInteger("subcontrol.latest_version")
def required_version = receiveInteger("subcontrol.required_version")
if ((latest_version == null) || (required_version == null)) {
  show("Version: "+ver_string+"\n\nWe are having trouble connecting to the server... this is critical, come back later. It may also be worth checking your firewall.")
  showButton("Restart")
  return "subcontrol_control"
}
if (this_version < required_version) { // Required Version check
  show("Version: "+ver_string+"\n\nA newer version of this script is available with some required features, please download")
  showButton("Yes")
  return
}
if (this_version < latest_version) { // Not Latest but should be Ok.. tell user about new version
  show("Version: "+ver_string+"\n\nA newer version of this script is available, it is not required but it would be good to download it anyway.")
  showButton("Yes")
} else {
  show("Version: "+ver_string)
}
wait(2)

// Display details of what has changed - only once for each Version
def splashver = loadInteger("subcontrol_control.splash")
if ((splashver == null) || (splashver < this_version)) {
  show("Version: "+ver_string+"\n\nIn this version:\nSaves to new V2 profiles.")
  showButton("OK")
  save("subcontrol_control.splash",this_version)
}

show("Loading...");

//check sex - Master or Mistress?
def mpic = null
def spic = null
def Msex = (!(!loadBoolean("intro.female")))
def MText = "Mistress"
if(!Msex)
  MText = "Master"
  
def timenow = getTime();
def mcode = loadString("subcontrol_control.mistress_code")
if (mcode != null)
  mcode = mcode.toUpperCase().replaceAll("[^0-9X]", "")
def scode = ""
def slist = loadString("subcontrol_control.subs") // store more than one sub in a list? - not on server!
if (slist == null)
  slist = ""
else
  slist = slist.toUpperCase().replaceAll("[^0-9Z,]", "")
  
// Slaves accepted offer in marketplace - in here so don't need to keep running marketplace script
def slaves = receiveString("slavemarket.slaves_"+mcode)
if (slaves != null) {
  if (slist == "") {
    slist = slaves
  } else {
    slist = slist+","+slaves
  }
  show("Adding new slaves: "+slaves+"\n\nFeel free to give them a welcome task")
  save("subcontrol_control.subs",slist)
  send("slavemarket.slaves_"+mcode,null)
  showButton("Ok");
}
// Replacement for SlaveMarket - Flag up if no subs
if (slist == "") {
  // Update list of Doms with no subs
  def link3 = 'http://play-link.com/subcontrol/available.php?id='+mcode+'&sex='+Msex
  link3 = link3.toURL().text
}
  
def List<String> Subs = slist.split(',')
def List<String> SubsN = []
def s_count = 0;
if (slist != "")
  s_count = Subs.size();
  
//Sub Vars
def sname
def s_times
def s_picchance
def s_watersports
def s_public
def s_reviewwebcam = false
def s_warnwebcam = false
 
//Create new mistress/master id if not found
if (mcode == null) {
  show("This script is for Masters and Mistresses only - Are you sure you should be here? If not exit now!")
  showButton("Ok")

  //have option to enter it! If being a Mistress on more than once device
  show("Welcome.\nWe do not have a record of you using this script before, generating a new ID");
  def tcode = getTime()-1426441764;
  mcode = getRandom(100000)+"X"+tcode;   // New code based on time to keep a match from happening
//	def i = getInteger("?",0);
  save("subcontrol_control.mistress_code", mcode)
  wait(4)
  show("Your "+MText+" ID is: "+mcode+"\n\nYour subs will need to enter it when they run their script for the first time. You will be able to see it at any time you run this script")
  showButton("Ok");
}

// Gen online profile if not found - Will have way to change it later
def mname = receiveString("subcontrolM.name_"+mcode)
def myfilename = null
if (mname == null) {
  show("We need to setup a profile that your subs will see ("+mcode+")...");
  wait(4)
  mname = getString("What name would you like your subs to use?",loadString("intro.name"));
  show("Now we need a profile pic");
  myfilename = getFile("Please choose your picture")  
  setImage(myfilename)
  mpic = myfilename

  //Send info to server
  send("subcontrolM.name_"+mcode,mname)
  send("subcontrolM.sex_"+mcode,loadBoolean("intro.female"))
  def myfilecode = sendImage(myfilename)
  if(myfilecode==null) {
	show("There was a problem, uploading image")
	wait(3)
  } else {
    send("subcontrolM.pic_"+mcode,myfilecode)
  }			
  // Keep a log of how many accounts are created and sex so get an idea who to target for
  // and how many people using this? - DO NOT STORE FULL ID's !
  def logusers = receiveString("subcontrol.newcusers")
  def logcode = mcode.tokenize('X')[0]
  if (loadBoolean("intro.female")) logcode += "F" else logcode += "M"
  if (logusers == null)
    send("subcontrol.newcusers",logcode)
  else
    send("subcontrol.newcusers",logusers+","+logcode)
  // End log
} else {
  Msex = (!(!receiveBoolean("subcontrolM.sex_"+mcode)))
  
  def myfilecode = receiveString("subcontrolM.pic_"+mcode)
  def mpic_code = loadString("subcontrol.control.mpic_code")
  // If can't get image from server try local copy & don't download if already done
  if (myfilecode == null) myfilecode = mpic_code
  if (myfilecode != null) {
    if (new File("images/received/"+myfilecode).exists())
	  mpic = "received/"+myfilecode
    else
	  mpic = receiveImage(myfilecode)
	save("subcontrol.control.mpic_code", myfilecode)
  }	   
}
// Reset MText
if (Msex) {
  MText = "Mistress"
} else {
  MText = "Master"
}

// *********************** Save profile for Version 2 *************************
  
  def mpassword = loadString("subcontrol.control.password")
  if (mpassword == null) { 
    mpassword = getString("You are now required to secure your account with a password:","password");
  }
  def v2profile = "http://play-link.com/subcontrol/save.php?id="+mcode+"&name="+URLEncoder.encode(mname,"UTF-8")+"&password="+URLEncoder.encode(mpassword,"UTF-8")+"&subs="+slist+"&sex="+Msex+"&"
	
  save("subcontrol.control.v2profile",v2profile)
  v2profile = v2profile.toURL().text
  show(v2profile) // Show if problem
  if (v2profile.contains("Error")) {
    showButton("Ok")
  }
  save("subcontrol.control.password",mpassword)
  
  // Upload Profile Image
  if ((mpic != null) && (mpic != "null") && (loadString("subcontrol.uploaded_cprofile_pic") == null))
  {
    def fupload
    if (new File("images/"+mpic).exists())
	  fupload = "images/"+mpic
    else
	  fupload = "images/"+receiveImage(mpic)
    def UploadResult = SendPLImage(mcode,"Profile","images/"+mpic);
	save("subcontrol.uploaded_cprofile_pic",fupload)
  }

// ******************* End Version2 ***************************


// Check if you got any messages? // Should store from id? as may not be from mistress?
def m_msg = receiveString("subcontrolM.msgs_"+mcode)

//s_msg = "Message 1\tMessage 2"
def m_msgcount = 0;
if ((m_msg != null) && (m_msg != ""))
  m_msgcount = m_msg.split('\t').size()
else
  m_msg = ""

// Update online list of subs - your subs can only run a task if on your mistresses list
if (s_count > 0) {
  def sublist = ""
  for (i in 1..Subs.size()) {
    sublist += Subs[i-1].tokenize('Z')[0]+","	
  }
  send("subcontrolM.subs_"+mcode,sublist)
}

// Download Tasks to buffer file.. should save time of last download as don't
// need to do more than once a day!
def mlink = "http://play-link.com/subcontrol/?sex=female&id="+mcode
def mfile = "subcontrol/main_female.txt" 
downloadFile(mlink,mfile)
mlink = "http://play-link.com/subcontrol/?sex=male&id="+mcode
mfile = "subcontrol/main_male.txt" 
downloadFile(mlink,mfile)
// End of tasks download

// Bitcoin checks
def bitcoin_mistress = loadString("subcontrol_control.bitcoin_wallet");
def bitcoin_mistress2 = receiveString("subcontrolM.bitcoin_wallet_"+mcode);
// If can't access server use local copy
if ((bitcoin_mistress2 == null) && (bitcoin_mistress != null))
  bitcoin_mistress2 = bitcoin_mistress
// If no local copy from server
if ((bitcoin_mistress2 != null) && (bitcoin_mistress == null)){
  save("subcontrol_control.bitcoin_wallet",bitcoin_mistress2)
  bitcoin_mistress = bitcoin_mistress2
}
// Check Bitcoin change...
if (bitcoin_mistress != bitcoin_mistress2) {
  show("Warning: It looks like someone has tampered with your bitcoin wallet details! please report this immediately. The two wallets we have are "+bitcoin_mistress+" and "+bitcoin_mistress2)
  showButton("OK")
}
  
//Sub Names - should update on sub view log
def status_string = "\n"
if (s_count > 0) {
  for (i in 1..Subs.size()) {
    // Why do we need to read this from server every time? Maybe check for name change when go into profile?
	def sub_name = loadString("subcontrol_control.name_"+Subs[i-1])
	if (sub_name == null) {
	  sub_name = receiveString("subcontrol.name_"+Subs[i-1])
      save("subcontrol_control.name_"+Subs[i-1],sub_name)
	}
	def log_data = receiveString("subcontrol.log_"+Subs[i-1])
	if (sub_name == null)
	  sub_name = "Not Found: "+Subs[i-1]
	if ((log_data != null) && (log_data != ""))
	  status_string += "\n"+sub_name+" activity" 
    SubsN.add(sub_name)
  }
}

def choice = -1
while(choice!=0) {
  setImage(mpic)
  // Should Display if get a msg from a sub in here...
  if (s_count > 0)
    choice = getSelectedValue("Your ID is: "+mcode+" You have "+s_count+" subs and "+m_msgcount+ " messages\n\n<b>Welcome "+MText+"</b> "+mname+status_string+"\n\nWhat would you like to do?",["Exit","Edit Profile", "Read Messages", "Review Tasks", "Slave Market", "Add/Remove a sub", "Review Sub"])
  else	
    choice = getSelectedValue("Your ID is: "+mcode+" You have no subs and "+m_msgcount+ " messages\n\n<b>Welcome "+MText+"</b> "+mname+status_string+"\n\nWhat would you like to do?",["Exit","Edit Profile", "Read Messages", "Review Tasks", "Slave Market", "Add a sub"])
  switch(choice) {
	case 1:
	    show("Updating profile...");
        mname = getString("What name would you like your subs to use?",mname);

        def rule = receiveString("subcontrolM.rule_"+mcode)
		if (rule == null) rule = ""
        rule = getString("Do you have any extra rules for your subs to be displayed when they ask?",rule);
		if (bitcoin_mistress == null) bitcoin_mistress = ""
        bitcoin_mistress = getString("Do you have a bitcoin wallet code to accept tips from your subs? It is easy to setup but please be careful as changing your wallet code may flag up warnings with your subs.",bitcoin_mistress);

        //Send info to server
        send("subcontrolM.name_"+mcode,mname)
        send("subcontrolM.sex_"+mcode,Msex)
		if ((rule == null) || (rule == "")) {
          send("subcontrolM.rule_"+mcode,null)
		} else {  
          send("subcontrolM.rule_"+mcode,rule)
		}
		if ((bitcoin_mistress == null) || (bitcoin_mistress == "")) {
          send("subcontrolM.bitcoin_wallet_"+mcode,null)
          save("subcontrol_control.bitcoin_wallet",null)
		} else {  
          send("subcontrolM.bitcoin_wallet_"+mcode,bitcoin_mistress)
          save("subcontrol_control.bitcoin_wallet",bitcoin_mistress)
		}  		
		
		if (getBoolean("Would you like to update your profile picture?")) {
          show("Lets update your profile pic");
		  myfilename = getFile("Please choose your picture")  
          setImage(myfilename)
          mpic = myfilename		
          def myfilecode = sendImage(myfilename)
          if(myfilecode==null) {
            show("There was a problem, uploading image")
	        wait(3)
          } else {
            send("subcontrolM.pic_"+mcode,myfilecode)
          }
		}
		break;
	case 2: // Read Messages - Send is via sub menu + should store old messages locally..
	    // Will make this better later but need to get working first
		def mailtext = ""
	    if (m_msgcount == 0)
		  mailtext  = "<b>Messages</b>\n\nNo new messages"
		else {
		  //try and match subs
		  mailtext  = "<b>New Messages</b>\n\n"
          //def msgs = m_msg.split('\t')
		  //def msgs = m_msg.tokenize('\t')
		  def List<String> msgs = m_msg.split('\t')
		  def line
		  for (i in 1..msgs.size()) {
           	line = msgs[i-1].tokenize('Z')
			def subname = line[0] 
			for (j in 1..Subs.size()) {
			  if (Subs[j-1].contains(line[0]))
                 subname = SubsN[j-1]
		    }
            mailtext += "<b>"+subname+"</b>\t"
            mailtext += line[1]+"\n"
		  }
		}  
		show(mailtext)
		showButton("Ok")
		
		// Clear Messages
		m_msg = ""
		m_msgcount = 0
        send("subcontrolM.msgs_"+mcode,"")
		break;
	case 3: // Goto Task Editor
        return "subcontrol/tasks"
        break;		
	case 4: // Goto Slave Market
        return "subcontrol/slavemarket"
        break;		
	case 5: // Add / remove Subs
        slist = getString("Edit the comma separated list of subs to add and delete them.",slist);
		save("subcontrol_control.subs", slist)
        Subs = slist.split(',')
        s_count = 0;
		SubsN = []
        if (slist != "") {
          s_count = Subs.size();
          for (i in 1..Subs.size()) {
	        def sub_name = loadString("subcontrol_control.name_"+Subs[i-1])
	        if (sub_name == null) {
	          sub_name = receiveString("subcontrol.name_"+Subs[i-1])
              save("subcontrol_control.name_"+Subs[i-1],sub_name)
          	}
			if (sub_name == null)
			  sub_name = "Not Found: "+Subs[i-1]
 		    SubsN.add(sub_name)
		  }
		}
		break;	
	case 6: // Review subs
	    if (s_count > 1) {
		  def sel_sub = getSelectedValue("Select the sub you want to review?",SubsN)
	      scode = Subs[sel_sub]
		} else {
		  scode = slist
        }		
		// Check you are a subs mistress - to stop subs having their own mistress to edit what they do
		def sub_mistress = receiveString("subcontrolM.mistress_code_"+scode)
		if (sub_mistress == null) sub_mistress = mcode
		if (sub_mistress != mcode) {
		  sub_mistress = sub_mistress+"(Not You)"
          show("<b>Error</b>\n\nThis sub has a someone else registered as their Mistress or Master")
          showButton("Ok")
//		  break;
		}

		// New Style profile
		def tprofile = receiveString("subcontrol.profile_"+scode)
		if (tprofile == null) { // New style profile not set yet?
          profile.name = receiveString("subcontrol.name_"+scode)
          profile.pic = receiveString("subcontrol.pic_"+scode)
          profile.reviewwebcam = receiveBoolean("subcontrol.reviewwebcam_"+scode)
  		  if (profile.reviewwebcam == null) profile.reviewwebcam = false
          profile.warnwebcam = receiveBoolean("subcontrol.warnwebcam_"+scode)
		  if (profile.warnwebcam == null) profile.warnwebcam = false
	      profile.picchance = receiveInteger("subcontrol.picchance_"+scode)
	      profile.sex = receiveBoolean("subcontrol.sex_"+scode)
		  profile.toys = receiveString("subcontrol.toys_"+scode)
		  profile.fetish = receiveString("subcontrol.fetish_"+scode)
	      profile.chastity = receiveInteger("subcontrol.chastity_"+scode)
	      profile.cumfrom = receiveInteger("subcontrol.cumfrom_"+scode)
          profile.mistress = receiveString("subcontrolM.mistress_code_"+scode)
          profile.LastTask = receiveString("subcontrol.LastTask_"+scode)
	      profile.LastTaskTime = receiveInteger("subcontrol.LastTaskTime_"+scode)
          profile.ImagesOfTask = receiveString("subcontrol.ImagesOfTask_"+scode)
          profile.TPic1 = receiveString("subcontrol.TPic1_"+scode)
          profile.TPic2 = receiveString("subcontrol.TPic2_"+scode)
          profile.TPic3 = receiveString("subcontrol.TPic3_"+scode)
		  // do we save here?
        } else {
		  tprofile = tprofile.replace("(","[").replace("{","[")
          profile = Eval.me(tprofile)
        }
		
        // Download Slave Pic if not already done
		def myfilecode = profile.pic
        if (myfilecode != null) {
          if (new File("images/received/"+myfilecode).exists())
	        spic = "received/"+myfilecode
          else
	        spic = receiveImage(myfilecode)
        } else
		  spic = null 
		
		// Temp put in old vars
		sname = profile.name
        s_picchance = profile.picchance
		def s_chancetext = ""
		if ((s_picchance == null) || (s_picchance == 1))
		  s_chancetext = "Always"
		else {
		  if (s_picchance == 100)
		    s_chancetext = "Never"
		  else  
		    s_chancetext = "1 in "+s_picchance+" chance"
        }		
		s_reviewwebcam = profile.reviewwebcam
        s_warnwebcam = profile.warnwebcam
        def s_sex = profile.sex
        def s_toys = profile.toys
        def s_fetish = profile.fetish
        def TaskText = profile.LastTask
		def s_forcetask = receiveInteger("subcontrol.forcetask_"+scode)
		
		def s_chastitytill = profile.chastity
		def s_cumfrom = profile.cumfrom
        def s_chastity_txt = "No"
		if ((s_chastitytill != null) && (s_chastitytill > getTime()))
		{
		  s_chastitytill = (s_chastitytill - getTime()) // Work if mistress in diff time zone to sub?
          if (s_chastitytill < (86400+86400)) { // if less than 2 days show in hours else days
		    s_chastity_txt = " Yes ("+Math.round(s_chastitytill/3600)+") Hours"
		  } else {
		    s_chastity_txt = " Yes ("+Math.round(s_chastitytill/86400)+") days"
		  }	
		}  
        def s_cum_txt = "Yes"
		if ((s_cumfrom != null) && (s_cumfrom > getTime()))
		{
		  s_cumfrom = (s_cumfrom - getTime()) // Work if mistress in diff time zone to sub?
          if (s_cumfrom < (86400+86400)) { // if less than 2 days show in hours else days
		    s_cum_txt = " No (Wait "+Math.round(s_cumfrom/3600)+") Hours"
		  } else {
		    s_cum_txt = " No (Wait "+Math.round(s_cumfrom/86400)+") days"
		  }	
		}  

        // Store if a Mistress reviews a sub - not used at the moment but may be useful
		// if a sub is paying to be monitored.. will see?
		def r_text = ""+getTime()+"-"+mcode.tokenize('X')[0]
        send("subcontrol.reviews_"+scode,r_text)
		
        myfilecode = profile.TPic1
		def uploadedpics = (myfilecode != null)
// Should repeat to save keep dropping out when dealing with a sub
def reviewopt = -1
while (reviewopt != 0) {
//        setImage(spic)
		setImageSize(spic,50)
		def mailtext = ""
	    reviewopt =getSelectedValue("Information on "+sname+" ("+scode+")\n\nUpload pic chance: "+s_chancetext+"\nForcetask?="+s_forcetask+"\nChastity: "+s_chastity_txt+"\nCan cum?: "+s_cum_txt+"\nReview before send:"+s_reviewwebcam+"\nWarn before take pic:"+s_warnwebcam+"\nFetishes:"+s_fetish+"\nToys:"+s_toys+"\nLast Task: "+TaskText+"\nUploaded task pics:"+uploadedpics+"\nSubs defined mistress: "+sub_mistress,["Back","Send Command","Send Msg", "Force a task", "Review uploads","View Log"])
		switch( reviewopt ) {
	      case 1: // Send command
		          // Also Send [MOOD:5] - should do as a choice not lots of questions!
		          if ( (s_toys.contains('chastity_belt')) && (getBoolean("Would you like to control their chastity device?")) ) {
				    mailtext += "[CHASTITY:"+getInteger("Hope many days would you like them locked up (0 to free)",0)+"]"
				  } else if (getBoolean("Would you like to control when they can cum?") ) {
				    mailtext += "[NOCUM:"+getInteger("Hope many days would you like them not to cum (0 to allow)",0)+"]"
				  } else if (getBoolean("Would you like to force your sub to take a punishment?") ) {
				    mailtext += "[PUNISH]"
				  }
		  case 2: // Send Message
		    def m_text = receiveString("subcontrol.msgs_"+scode)
		    if (m_text == null) m_text = ""
		    mailtext += getString("Enter a message, this should not be used as a regular form of communication","");
		    if (m_text == "")
		      m_text = mailtext
		    else
		  	  m_text = m_text+"\t"+mailtext
            send("subcontrol.msgs_"+scode,m_text)
 		    break
		  case 3: // Force Task
            // New way from Local downloaded file
			def List<String> TaskList = ["Clear - No pre-set task","Force a local task"]
			def fname = "main_male" 
	        if (s_sex)
              fname = "main_female"
		    fname = "scripts/subcontrol/"+fname+".txt"  
		    def f1 = new File(fname)
		    def lines = f1.readLines()
            def i=0;
            lines.each {
		      def Title = it.tokenize('[')[0]
		      TaskList.add(Title.tokenize(']')[1]);
	          i=i+1;
            }
			// End of new way
            def forcetask = getSelectedValue("Select a task you would like to force "+sname+" to do next time they login ("+TaskList.size()+" tasks).",TaskList)-2
			
			if (forcetask == -1) {
              fname = "tasks_male" 
	          if (s_sex)
                fname = "tasks_female"
		      fname = "scripts/subcontrol/"+fname+".txt"  
              if (!(new File(fname).exists())) {
		        show("Error: file not found "+fname+" create some local tasks first!")
                showButton("OK") 		   
                break
		      }
		      f1 = new File(fname)
		      lines = f1.readLines()
		      TaskList = []
              i=0;
              lines.each {
		        def Title = it.tokenize('[')[0]
		        TaskList.add(Title.tokenize(']')[1]);
	            i=i+1;
              }
              def TNo = getSelectedValue("Select a task you would like to send to "+sname,TaskList)		 
              send("subcontrol.mtask_"+scode,lines[TNo])			  
		    }
			if (forcetask == -2)
			  forcetask = -1
            send("subcontrol.forcetask_"+scode,forcetask)
			s_forcetask = forcetask
		    break
		  case 4: // Review uploaded images
            // Store if a Mistress reviews a sub - not used at the moment but may be useful
		    // if a sub is paying to be monitored.. will see?
			/* Change to just store date of last review - will never be a need for
			   a complete list!
		    r_text = receiveString("subcontrolM.reviews_"+mcode)
		    if (r_text == null) r_text = ""
		    if (r_text != "")
		      r_text += "\t"
			*/  
			def logdate = new Date()
		    r_text = ""+logdate+"-"+scode.tokenize('Z')[0]
            send("subcontrolM.reviews_"+mcode,r_text)
		  
		    if (uploadedpics) { // should stop displaying option if none uploaded
			  show("Show images for last uploaded task ("+receiveString("subcontrol.ImagesOfTask_"+scode)+")")
			  
			  myfilecode = profile.TPic1
			  def tpic = null
              if (myfilecode != null) {
                if (new File("images/received/"+myfilecode).exists())
	              tpic = "received/"+myfilecode
                else
	              tpic = receiveImage(myfilecode)
              }
              setImage(tpic)
			  if (tpic != null)
			    new File(tpic).delete()
		      showButton("Pic 1 (Next)")

			  myfilecode = profile.TPic2
              if (myfilecode != null) {
                if (new File("images/received/"+myfilecode).exists())
	              tpic = "received/"+myfilecode
                else
	              tpic = receiveImage(myfilecode)
              } else
		        tpic = null
              setImage(tpic)
			  if (tpic != null)
			    new File(tpic).delete()		  
		      showButton("Pic 2 (Next)")

			  myfilecode = profile.TPic3
              if (myfilecode != null) {
                if (new File("images/received/"+myfilecode).exists())
	              tpic = "received/"+myfilecode
                else
	              tpic = receiveImage(myfilecode)
              } else
		        tpic = null
              setImage(tpic)
			  if (tpic != null)
                new File(tpic).delete()
		      showButton("Pic 3 (Done)")

			  // Show last chastity lock image (If sub using it)
			  myfilecode = receiveString("subcontrol.ch_image_"+scode)
              if (myfilecode != null) {
                if (new File("images/received/"+myfilecode).exists())
	              tpic = "received/"+myfilecode
                else
	              tpic = receiveImage(myfilecode)
              } else
		        tpic = null
			  if (tpic != null) {
                setImage(tpic)
                new File(tpic).delete()
			    show("Last chastity lock combination image")
		        showButton("Done")
			  }	
			}
		    break
		  case 5 : def log_data = receiveString("subcontrol.log_"+scode)
		    def mobile = 'http://play-link.com/control.php?id='+scode
            log_data = log_data + mobile.toURL().text
		    setImage(null) // clear image more space for log
            show("<b>Log data</b>\n\n"+log_data+"\n\n(saved to file scripts/subcontrol/log_"+scode+".txt)")
			// append data to log file for sub and clear
			def f1 = new File("scripts/subcontrol/log_"+scode+".txt")
            f1 << log_data+"\n"
			send("subcontrol.log_"+scode,"") 
			// Popup full log file
			useFile("scripts/subcontrol/log_"+scode+".txt");
			
			//Update active list
            status_string = "\n"
            if (s_count > 0) {
              for (i in 1..Subs.size()) {
			    if (Subs[i-1] == scode)
				  log_data = ""
				else  
	              log_data = receiveString("subcontrol.log_"+Subs[i-1])
	            if ((log_data != null) && (log_data != ""))
	              status_string += "\n"+SubsN[i-1]+" activity" 
              }
            }
			
		    showButton("Ok")
			break
		}	
} // end while loop for sub review		
		break;	
	 
  }		
}

setImage(null)
show("Goodbye")
wait(1)
exit()

// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/

/*
 * Resources
 * scripts/subcontrol_control.groovy
 * scripts/subcontrol/tasks.groovy
 * scripts/subcontrol/slavemarket.groovy
 * scripts/subcontrol/main_female.txt
 * scripts/subcontrol/main_male.txt
 * images/subcontrol/msplash.png
 */
